/* GCC */

#include <iostream>
#include <fstream>

using namespace std;

int getAN(int n)
{
    int add=0;
    if((n-1)%3==1) add=2;
    if((n-1)%3==2) add=3;
    int c=1+((n-1)/3)*5+add;
    return c;
}

int getBN(int n)
{
    int add=0;
    if((n-1)%3==1) add=3;
    if((n-1)%3==2) add=5;
    int c=2+((n-1)/3)*8+add;
}


int table[10000009];
int untable[10000009];

void fill_array(int n)
{
    int bcounter=1;
    int acounter=1;
    for(int i=0;i<n;i++)
    {
        untable[i]=-1;
    }
    for(int i=1;i<n;i++)
    {

        if((i)%5==2 || (i)%5==0)
        {
            table[i]=getAN(acounter);
            acounter++;
        }
        else
        {
            table[i]=getBN(bcounter);
            bcounter++;
        }
        untable[table[i]]=i;
    }
}

int testX(int cx,int cy)
{
    for(int r=0;(cx-r)>=0;r++)
        if(table[cx-r]==cy)
            return r;
    return 0;
}

int testY(int cx,int cy)
{
    for(int r=0;(cy-r)>=0;r++)
        if(untable[cy-r]==cx)
           return r;
    return 0;
}

int testXY(int cx,int cy)
{
    for(int r=0;(cx-r)>=0&&(cy-r)>=0;r++)
    {
     //  cout<<"X="<<(cx-r)<<"Y="<<(cy-r)<<"table[cx-r]="<<table[cx-r]<<endl;
        if(table[cx-r]==cy-r&&untable[cy-r]==cx-r)
        return r;
    }
    return 0;
}


int main()
{
    ifstream inpu("stones.in",ios_base::in);
    ofstream outp("stones.out",ios_base::out);
    int a,b;
    inpu>>a;
    inpu>>b;
    a>b ? fill_array(a+1) : fill_array(b+1);
    int tx=testX(a,b);
    int ty=testY(a,b);
    int txy=testXY(a,b);
    int r=tx;
    if(ty>r) {r=ty;tx=0;};
    if(txy>r){ r=txy;ty=0;};
    outp<<tx<<" "<<ty<<" "<<txy<<endl;
    outp.close();
    inpu.close();
    return 0;
}
