/* GCC */
#include <iostream>

#define MAX 450

using namespace std;

int m[MAX+1][MAX+1];
int calc(int a,int b);
int solve(int a,int b);

int calc(int a,int b)
{
    if(m[a][b]==-1 && m[b][a]==-1) m[a][b] = m[b][a] = solve(a,b);
    else if(m[a][b]==-1) m[a][b] = m[b][a];
    return m[a][b];
}

int solve(int a,int b)
{
    for(int i=0;i<a;++i) if(!calc(i,b))  return 1;
    for(int i=0;i<b;++i) if(!calc(a,i))  return 1;
    for(int i=1;i<=min(a,b);++i) if(!calc(a-i,b-i)) return 1;
    return 0;
}

int a,b,c,d;

int main()
{
    freopen("stones.in","r",stdin);
    freopen("stones.out","w",stdout);
        cin >> c >> d;
        a=c;
        b=d;
    if(!(a<MAX && b<MAX)) {a=MAX; b=MAX;}
        memset(m,-1,sizeof(m));
        for(int i=0;i<MAX;++i) for(int j=0;j<MAX;++j) calc(i,j);
        int ans = 0;
        int t=-1;
        if(!(c>MAX || d>MAX))
        {for(int i=a;i>=1;--i)if(!m[a-i][b])  {if(i>ans) {ans=i;t=0;}break;}
        for(int i=b;i>=1;--i) if(!m[a][b-i])  { if(i>ans) {ans=i;t=1;} break;}
        }for(int i=min(c,d);i>max(0,max(c-MAX,d-MAX));--i) if(!m[c-i][d-i]) {if(i*2>ans) {ans=i;t=2;}break;}
        if(!t) cout << ans << " 0 0" << endl;
        else if(t==1) cout << "0 " << ans <<" 0" <<  endl;
        else cout << "0 0 " << ans << endl;
        return 0;


}
