/* GCC */
#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

int main()
{
    ifstream input ("race.in", ios::in);
    if (!input)
    {
        cout << "No input file" << endl;
        return 1;
    }

    float total_time, from, to, fast, slow;
    input >> total_time >> from >> to >> fast >> slow;
    vector<float> energies;

    float tmp;
    for (float i = 0; i < total_time; i++)
    {
        input >> tmp;
        energies.push_back(tmp);
    }
    input.close();

    float snack_power = (fast * slow)/(fast + slow);
    float snack_time = from + to;
    float snacks;
    if (snack_time > total_time)
    {
        snacks = 1;
    }
    else
    {
        float total_power;
        for (int i = 0; i < (int)total_time; i++)
            total_power += energies[i];
        cout << total_power << endl;
        snacks = total_power / (snack_power * total_time);
    }
    cout << snacks << endl;
    int result = (int)(snacks + 0.99);

    ofstream output ("race.out", ios::out);
    output << result << endl;
    output.close();
}
