{ Free Pascal }
const nmax=1234567;

type
  Telem = record
    ver:longword;
    next:longword;
  end;
  Tver = record
    parent:longword;
    timein:longword;
    timeout:longword;
  end;
  Tlist = array[1..nmax] of telem;
  Tmas = array[1..nmax] of longword;
  Tdata = array[1..nmax] of tver;

var f1,f2:text;

procedure FillList(var L:Tlist; var curs:Tmas; var c:Tmas; var n:longword);
  var
    v1,v2,i:longword;
  begin
    fillchar(curs, sizeof(curs), 0);
    i:=1;
    n:=1;
    while not seekEOF(f1) do
      begin
        read(f1, v1,v2);
        if n<v1 then n:=v1;
        if n<v2 then n:=v2;
        L[2*i-1].ver:=v2;
        L[2*i-1].next:=curs[v1];
        curs[v1]:=2*i-1;
        c[v1]:=2*i-1;
        L[2*i].ver:=v1;
        L[2*i].next:=curs[v2];
        curs[v2]:=2*i;
        c[v2]:=2*i;
        inc(i);
      end;
  end;

procedure TimeoutS(v:longword; var D:Tdata; L:Tlist; C:Tmas);
  var
    min:longword;
    t:longword;
  begin
    min:=D[v].timein;
    while c[v]>0 do
      if L[C[v]].ver <> D[v].parent then
        begin
          t:=L[c[v]].ver;
          if d[t].timeout=0 then
            if min > d[t].timein then min:=d[t].timein
          else
            if min > d[t].timeout then min:=d[t].timeout;
          c[v]:=L[c[v]].next;
        end
      else c[v]:=L[c[v]].next;
    D[v].timeout:=min;
  end;

var
  List:Tlist;
  cursor, cursorc:Tmas;
  visited:array[1..nmax] of boolean;
  Data:Tdata;
  v,t,top,i:longword;
  stack:Tmas;
  lastv:longword;
  bridge:array[1..nmax, 1..2] of longword;
begin
  assign(f1, 'crossing.in');
  assign(f2, 'crossing.out');
  reset(f1);
  rewrite(f2);
  FillList(List, Cursor, cursorc, lastv);
  fillchar(visited, sizeof(visited), 0);
  fillchar(stack, sizeof(stack),0);
  top:=1;
  i:=1;
  while cursor[i]=0 do inc(i);
  stack[top]:=List[cursor[i]].ver;
  cursorc[i]:=List[cursor[i]].next;
  v:=stack[top];
  visited[v]:=true;
  Data[v].timein:=1;
  while top>0 do
    begin
      if cursorc[v] = 0 then
        begin
          TimeoutS(v, Data, List, Cursor);
          dec(top);
          v:=stack[top];
        end
      else begin
        inc(top);
      end;
      t:=cursorc[v];
      if not visited[List[t].ver]
      then begin
        visited[List[t].ver]:=true;
        Data[List[t].ver].parent:=v;
        cursorc[v]:=List[t].next;
        v:=List[t].ver;
        stack[top]:=v;
        Data[v].timein:=Data[Data[v].parent].timein + 1;
      end
      else
          cursorc[v]:=List[t].next;
    end;
  t:=1;
  for i:=2 to lastv do
    if data[i].timein = data[i].timeout then
      begin
        bridge[t,2]:=i;
        inc(t);
      end;
  v:=t-1;
  t:=1;
  while bridge[v,1] = 0 do
    for i:=2 to lastv do
      if data[i].timein + 1 = data[bridge[t,2]].timein then
        begin
          bridge[t,1]:=i;
          inc(t);
        end;
  for i:=1 to v do writeln(f2, bridge[i,1], ' ', bridge[i,2]);
  close(f1);
  close(f2);
end.
