/* GCC */
#include <iostream>
#include <stdio.h>
#include <math.h>
#include <vector>
#include <algorithm>
#include <string.h>
#include <string>
#include <map>

using namespace std;

const int INF = 2000000000;
const int MAXN = 1235000;

int a, b, ind, v;
int to[2 * MAXN], n[2 * MAXN], cursor[MAXN];
int ans[MAXN], sz;
bool used[MAXN];
int t[MAXN], f[MAXN], timer;

void addEdge(int a, int b)
{
    to[ind] = b;
    n[ind] = cursor[a];
    cursor[a] = ind;
    ++ind;
}

void dfs(int v, int p = -1)
{
    used[v] = true;
    t[v] = f[v] = ++timer;
    int cnt = 0;
    for (int i = cursor[v]; i != -1; i = n[i])
    {
        if (to[i] == p) continue;
        if (used[to[i]])
            f[v] = min(f[v], t[to[i]]);
        else
        {
            ++cnt;
            dfs(to[i], v);
            f[v] = min(f[v], f[to[i]]);
            if (p != -1 && t[v] <= f[to[i]])
                ans[sz++] = v;
        }
    }
    if (p == -1 && cnt > 1)
        ans[sz++] = v;
}

int main()
{
    freopen("crossing.in", "r", stdin);
    freopen("crossing.out", "w", stdout);

    v = -1;
    for (int i = 0; i < MAXN; ++i)
        cursor[i] = -1;
    while (scanf("%d %d", &a, &b) == 2)
    {
        if (v == -1)
            v = a;
        addEdge(a, b);
        addEdge(b, a);
    }
    dfs(v);
    sort(ans, ans + sz);
    if (sz)
        printf("%d", ans[0]);
    for (int i = 1; i < sz; ++i)
        printf(" %d", ans[i]);
    printf("\n");
    return 0;
}
