{ Free Pascal }
program race;
const NMax = 200000;
type TRecord = Record
     power, cur_power:LongInt;
     end;
type TData = array [1..NMax] of TRecord;
var data:TData;
    n, t1,t2,a,b:longint;

procedure read_data(var data:TData; var n,t1,t2,a,b:longint);
 var i: longint;
 begin
        fillchar(data, sizeof(data), 0);
        read(n, t1, t2, a, b);
         for i := 1 to n do
          read(data[i].power);
 end;

procedure add_power(var data:TData; var index,t1,t2,a,b:longint);
 var i:longint;
 begin
        for i := index to index+t1-1 do
         inc(data[i].cur_power, a);
        for i := index to index+t2-1 do
         inc(data[i].cur_power, b);
 end;

procedure solve(var data:TData; n,t1,t2,a,b:longint);
 var count, index, i:longint;
 begin
        count:=0;
        index:=1;
        while  (data[n].cur_power<=data[n].power) do
         begin
          while (data[index].power <= data[index].cur_power) and (index<=n) do inc(index);
           add_power(data, index, t1, t2, a, b);
           inc(count);
         end;
         writeln(count);
 end;

begin
        assign(input, 'race.in');
        reset(input);
        assign(output, 'race.out');
        rewrite(output);
        read_data(data, n, t1, t2, a, b);
        solve(data, n, t1, t2, a, b);
        close(output);
        close(input);
end.
