/* GCC */
#include <iostream>
#include <algorithm>
#include <memory.h>
#include <cstdlib>
#include <cstring>
#include <vector>
#include <string>
#include <stack>
#include <cmath>
#include <ctime>
#include <queue>
#include <map>
#include <set>

using namespace std;

#define pb push_back
#define mp make_pair
#define ppb pop_back
#define sd second
#define fs first

#define inf 1000000007
#define nmax 10000100
#define mmax 1334568
#define eps 1e-7

int a, b, ptr, aa, bb, cc;
int x[4000500], y[4000500];
bool dp[1010][1010], u[10000500]; 

void bad_sol()
{
	int n = 1000;
	for(int i = 0; i <= n; ++i)
		for(int j = 0; j <= n; ++j)
			if(!dp[i][j])
			{
				for(int ii = i + 1; ii <= n; ++ii)
					dp[ii][j] = 1;
				for(int jj = j + 1; jj <= n; ++jj)
					dp[i][jj] = 1;
				for(int d = max(i, j) + 1; d <= n; ++d)
					dp[i + d - max(i, j)][j + d - max(i, j)] = 1;
			}
	aa = bb = cc = 0;
	for(int d = 1; min(a, b) - d >= 0; ++d)
		if(!dp[a - d][b - d])
			cc = d;
	for(int d = 1; a - d >= 0; ++d)
		if(!dp[a - d][b])
			aa = d;
	for(int d = 1; b - d >= 0; ++d)
		if(!dp[a][b - d])
			bb = d;
}

void good_sol()
{
	u[0] = 1;
	while(x[ptr] < nmax)
	{
		int nx = x[ptr] + 2, ny = y[ptr] + 1;
		nx += u[ny]; ny += u[ny];
		++ptr; x[ptr] = nx; y[ptr] = ny; u[nx] = u[ny] = true;
	}
	aa = bb = cc = 0;
	for(int i = 0; i < ptr; ++i)
		for(int j = 0; j < 2; ++j)
		{
			if(b == y[i] && a - x[i] > 0)
				aa = max(aa, a - x[i]);
			if(a == x[i] && b - y[i] > 0)
				bb = max(bb, b - y[i]);
			if(a - x[i] == b - y[i] && a - x[i] > 0)
				cc = max(cc, a - x[i]);
			swap(x[i], y[i]);
		}
}

int main()
{
	freopen("stones.in", "r", stdin); freopen("stones.out", "w", stdout);
	cin >> a >> b;
	if(max(a, b) <= 1000)
		bad_sol();
	else
		good_sol();
	printf("%d %d %d\n", aa, bb, cc);
	//while(1);
}
