/* GCC */
#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <vector>

using namespace std;

vector <int> graph[1234567] , ans;
int time , x , y , Tin[1234567] , Tout[1234567];
bool visited[1234567];

void dfs(int v , int p = -1)
{
    Tin[v] = time++;
    Tout[v] = Tin[v];
    visited[v] = true;
    int ch = 0;
    for (int i = 0; i < graph[v].size(); i++)
    {
        int dest = graph[v][i];
        if (dest != p)
        {
            if (visited[dest])
                Tout[v] = min (Tout[v] , Tin[dest]);
            else
            {
                dfs(dest , v);
                Tout[v] = min (Tout[v] , Tout[dest]);
                if ((Tin[v] <= Tout[dest]) && (p != -1))
                    ans.push_back(v + 1);
                ch++;
            }
        }
    }
    if ((ch > 1) && (p == -1))
        ans.push_back(v + 1);
}

int main()
{
    freopen ("crossing.in" , "r" , stdin);
    freopen ("crossing.out" , "w" , stdout);
    while (scanf("%d %d" , &x , &y) != -1)
    {
        graph[x - 1].push_back(y - 1);
        graph[y - 1].push_bacck(x - 1);
    }
    dfs (0);
    sort (ans.begin() , ans.end());
    cout << ans[0];
    for (int i = 1; i < ans.size(); i++)
        printf(" %d" , ans[i]);
    cout << endl;
}
