/* GCC */

//#include<iostream>
#include<fstream>
#include<vector>

void f(std::vector<std::vector<int> > &graph, std::vector<bool> &res, std::vector<int> &x, std::vector<int> &y, int v, int &c) {
    /*std::cout << "f([...], [";
    for (std::vector<bool>::iterator i = res.begin(); i != res.end(); i++)
        std::cout << *i << ",";
    std::cout << "], [";
    for (std::vector<int>::iterator i = x.begin(); i != x.end(); i++)
        std::cout << *i << ",";
    std::cout <<"], " << v << ", " << c << ")" << std::endl;*/

    x[v] = y[v] = c;
    c++;

    for (std::vector<int>::iterator i = graph[v].begin(); i != graph[v].end(); i++) {
        if (x[*i] == -1) {
            f(graph, res, x, y, *i, c);
            y[v] = std::min(y[v], y[*i]);
        }
        y[v] = std::min(y[v], x[*i]);
    }

    for (std::vector<int>::iterator i = graph[v].begin(); i != graph[v].end(); i++) {
        if (y[*i] >= x[v]) {
            res[v] = true;
            break;
        }
    }
    
    //std::cout << y[v] << std::endl;
}

void f(std::vector<std::vector<int> > &graph, std::vector<bool> &res, int v) {
    std::vector<int> x(graph.size(), -1);
    std::vector<int> y(graph.size(), -1);
    int c = 0;
    f(graph, res, x, y, v, c);
}

int main() {
    std::ifstream fin("crossing.in");
    std::ofstream fout("crossing.out");

    std::vector<std::vector<int> > graph;
    
    while (true) {
        int a, b;
        fin >> a >> b;
        if (fin.eof()) break;
        
        a--; b--;
        //std::cout << a << " " << b << std::endl;
        while (a >= graph.size()) graph.push_back(std::vector<int>());
        while (b >= graph.size()) graph.push_back(std::vector<int>());
        graph[a].push_back(b);
        graph[b].push_back(a);
    }

    std::vector<bool> res(graph.size(), false);
    f(graph, res, 0);
    res[0] = false;
    f(graph, res, 1);
    
    bool first = true;
    for (int i = 0; i < graph.size(); i++) {
        if (res[i]) {
            if (!first) fout << " ";
            fout << i + 1;
            first = false;
        }
    }

    fout << std::endl;
    //std::cin.get();

    return 0;
}
