/* GCC */

#include<fstream>
#include<vector>

int main() {
    std::ifstream fin("race.in");
    std::ofstream fout("race.out");

    int n, t1, t2, a, b;
    fin >> n >> t1 >> t2 >> a >> b;
    
    std::vector<int> p(n);
    for (int i = 0; i < n; i++)
        fin >> p[i];
    
    if (a < b) {
        std::swap(a, b);
        std::swap(t1, t2);
        for (int i = 0; i < n / 2; i++)
            std::swap(p[i], p[n - 1 - i]);
    }
    
    std::vector<int> x(n);
    int current = 0;
    unsigned long long res = 0;
    for (int i = 0; i < n; i++) {
        if (i >= t1) current -= x[i - t1] * (a - b);
        if (i >= t1 + t2) current -= x[i - t1 - t2] * b;

        //fout << i << "\t" << x[i] << "\t" << p[i] << "\t" << current << std::endl;

        if (p[i] >= current) {
            x[i] = (p[i] - current - 1) / a + 1;
            res += x[i];
            current += x[i] * a;
        }
        
        //fout << i << "\t" << x[i] << "\t" << p[i] << "\t" << current << std::endl;
    }
    
    fout << res << std::endl;

    return 0;
}
