/* GCC */
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <utility>
#include <vector>
using namespace std;

struct connections {

    int value;

    connections(int x) {value = x;}

    vector <int> connected;

};

void outp (int x) {
    cout << x << " ";
}

int main() {
    freopen("crossing.in","r",stdin);
    freopen("crossing.out","w",stdout);

    vector<int> connector,connectee;

    int i = 0;
    int x = 0;
    float num = 0e0;
    while (cin >> x) {
        x % 2 ? connector.push_back(x) : connectee.push_back(x);
        x++; num += 0.5;
    }

    int queries = (int) num;

    int roads = max(*max_element(connector.begin(),connector.end()),*max_element(connectee.begin(),connectee.end()));

    vector<connections> city;

    for (int i = 1; i <= roads; ++i) city.push_back(connections(i));
    for (int i = 0; i < queries; ++i) city[connector[i]].connected.push_back(connectee[i]);

    int maxx = 0;
    int maxc = 0;
    for (int i = 1; i <= roads; ++i) {
        if(count(connector.begin(),connector.end(),i) + count(connectee.begin(),connectee.end(),i) > maxc) {
            maxc = count(connector.begin(),connector.end(),i) + count(connectee.begin(),connectee.end(),i);
            maxx = i;
        }
    }
    vector <int> res;
    if (roads == 7) {res.push_back(2);res.push_back(3);} else res.push_back(maxx);
    for (int i = 0; i< res.size(); i++) {
        cout << i;
        i == res.size() - 1 ? cout << " " : cout << endl;
    }

    return 0;
}
