/* GCC */
#include <iostream>
#include <fstream>
#include <map>
#include <vector>
#include <algorithm>

using namespace std;

bool seek(map<int, vector<int> > dict, int edge, int point)
{
    if (find(dict[edge].begin(), dict[edge].end(), point) == dict[edge].end())
    {
        cout << point << " not in dict " << edge << endl;
        if ((int)dict[edge].size() > 0)
        {
            for (int i = 0; i < (int)dict[edge].size(); i++)
            {
                bool result = seek(dict, dict[edge][i], point);
                if (result)
                    return true;
            }
        }
        else
            return false;
    }
    else
    {
        cout << point << " in dict " << edge << endl;
        return true;
    }
    return false;
}

int main()
{
    ifstream input ("crossing.in", ios::in);
    if (!input)
    {
        cout << "No input file" << endl;
        return 1;
    }

    int tmp1, tmp2;
    map<int, vector<int> > graph;

    while (input)
    {
        input >> tmp1 >> tmp2;
        graph[tmp1].push_back(tmp2);
    }
    input.close();

    vector<int> bad;

    for (map<int, vector<int> >::iterator i = graph.begin(); i != graph.end(); i++)
    {

        pair<int, vector<int> > tmp = *i;
        cout << i->first << endl;
        graph.erase(tmp.first);
        if (!seek(graph, graph.begin()->first, tmp2))
        {
            bad.push_back(tmp.first);
            if ((int)bad.size() == 2)
                break;
        }
        else
            graph.insert(graph.begin(), tmp);
    }

    ofstream output ("crossing.out", ios::out);
    output << bad.at(0) << " " << bad.at(1) << endl;
    output.close();
    return 0;
}
