/* GCC */
#include <iostream>
#include <fstream>
#include <algorithm>
#include <map>

using namespace std;

int main()
{
    ifstream input ("stones.in", ios::in);
    if (!input)
    {
        cout << "No input file" << endl;
        return 1;
    }

    int pile_f, pile_s;
    input >> pile_f >> pile_s;

    map<int, int> cosher;
    cosher.insert(make_pair(2,1));
    cosher.insert(make_pair(5,3));
    cosher.insert(make_pair(7,4));
    cosher.insert(make_pair(10,6));
    cosher.insert(make_pair(13,8));
    cosher.insert(make_pair(15,9));
    cosher.insert(make_pair(18,11));

    map<int, int> reverse_cosher;
    for (map<int, int>::iterator i = cosher.begin(); i != cosher.end(); i++)
        reverse_cosher[i->second] = i->first;

    int move_f = 0;
    int move_s = 0;
    int move_b = 0;

    if (cosher.find(pile_f) != cosher.end())
    {
        if (pile_s > cosher[pile_f])
        {
            move_s = pile_s - cosher[pile_f];
        }
    }
    if (reverse_cosher.find(pile_f) != reverse_cosher.end())
    {
        if (pile_s > reverse_cosher[pile_f])
        {
            move_s = pile_s - reverse_cosher[pile_f];
        }
    }

    ofstream output ("stones.out", ios::out);
    output << move_f << " " << move_s << " " << move_b << endl;
    output.close();
    return 0;
}
