/* GCC */
#include <fstream>
#include <utility>
#include <vector>
#include <algorithm>
std::vector<size_t> used;
bool hasOneWay(const std::vector<size_t>& v, const std::vector<size_t>& v2,
     size_t i, size_t j, bool rec = false)
{
     bool good = true;
     std::vector<size_t>::const_iterator it = find(v.begin(), v.end(), i);
     for(; it < v.end(); it++)
     {
           if(*it == i && v2[it - v.begin()] != j && find(used.begin(), used.end(), *it) == used.end())
           {
                  used.push_back(i);
                  good = hasOneWay(v, v2, v2[it-v.begin()], j, true);
                  used.erase(find(used.begin(), used.end(), i));
           }
           else if(rec && v2[it - v.begin()] == j)
                  good = false;
           if(!good)
                  break;
     }
     if(good)
     {
             it = find(v2.begin(), v2.end(), i);
             for(; it < v2.end(); it++)
             {
                  if(*it == i && v[it - v2.begin()] != j && find(used.begin(), used.end(), *it) == used.end())
                  {
                           used.push_back(i);
                           good = hasOneWay(v, v2, v[it-v2.begin()], j, true);
                           used.erase(find(used.begin(), used.end(), i));
                  }
                  else if(rec && v2[it - v.begin()] == j)
                       good = false;
                  if(!good)
                       break;
             }
     }
     return good;
}
int main(void)
{
    std::vector<size_t> v;
    std::vector<size_t> v2;
    std::vector<size_t> res;
    size_t max = 0;
    std::ifstream in("crossing.in");
    size_t temp = 0;
    while(in >> temp)
    {
             if(temp > max)
                     max = temp;
             v.push_back(temp);
             in >> temp;
             if(temp > max)
                     max = temp;
             v2.push_back(temp);
    }
    in.close();
    for(size_t i = 1; i < max; i++)
    {
               for(size_t j = i+1; j < max+1; j++)
               {
                          if(hasOneWay(v, v2, i, j))
                          {
                           if(find(res.begin(), res.end(), i) == res.end())
                                                    res.push_back(i);
                           if(find(res.begin(), res.end(), j) == res.end())
                                                    res.push_back(j);
                          }
               }
    }
    std::sort(res.begin(), res.end(), std::less<size_t>());
    std::ofstream out("crossing.out");
    for(std::vector<size_t>::const_iterator it = res.begin(); it!= res.end(); it++)
             out << *it << ' ';
    out << '\n';
    out.close();
    return 0;
}
