/* GCC */
#include <iostream>
#include <stdio.h>
#include <math.h>
#include <vector>
#include <algorithm>
#include <string.h>
#include <string>
#include <map>

using namespace std;

const int INF = 2000000000;
const int MAXN = 100010;

int N, t1, t2, a, b;
int p[MAXN];

long long f()
{
    long long ans = 0;
    for (int i = 0; i < N; ++i)
    {
        if (p[i] == 0) continue;
        while (p[i])
        {
            long long sum1 = 0;
            long long sum2 = 0;
            for (int j = 0; j < t1; ++j)
                if (i + j < N)
                    sum1 += min(a, p[i + j]);
            for (int j = 0; j < t2; ++j)
                if (i + j < N)
                    sum2 += min(b, p[i + j]);
            if (sum1 >= sum2)
            {
                int k = p[i] / a;
                if (p[i] - a * k > 0)
                    ++k;
                ans += k;
                for (int j = 0; j < t1; ++j)
                    if (i + j < N)
                        p[i + j] -= min(a, k * p[i + j]);
                for (int j = 0; j < t2; ++j)
                    if (i + t1 + j < N)
                        p[i + t1 + j] -= min(b, k * p[i + t1 + j]);
            }
            else
            {
                int k = p[i] / b;
                if (k == 0)
                    ++k;
                ans += k;
                for (int j = 0; j < t2; ++j)
                    if (i + j < N)
                        p[i + j] -= min(b, k * p[i + j]);
            }
        }
    }
    return ans;
}

int main()
{
    freopen("race.in", "r", stdin);
    freopen("race.out", "w", stdout);
    scanf("%d %d %d %d %d", &N, &t1, &t2, &a, &b);
    for (int i = 0; i < N; ++i)
        scanf("%d", &p[i]);
    cout << f() << endl;
    return 0;
}
