/* GCC */

#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <math.h>
#include <stdlib.h>

const int maxi= 1234567;
using namespace std;

struct tt{
    int a, next;
};

bool used[maxi +7], isco[maxi+7];
int tin[maxi+7], fup[maxi+7], timr=0, top=0, cursor[maxi+7];
tt listt[2*maxi + 7];

void add(int a, int b)
{
   listt[++top].a= b;
   listt[top].next= cursor[a];
   cursor[a]= top;
   listt[++top].a= a;
   listt[top].next= cursor[b];
   cursor[b]= top;
}

void dfs(int v, int p)
{
    used[v]= true;
    tin[v]= fup[v]= ++timr;
    int go= cursor[v], to;
    int child= 0;
    while(go!=0)
    {
       to= listt[go].a;
       if (to!=p) {
         if (used[to])
            fup[v]= min(fup[v], tin[to]);
         else {
             dfs(to ,v);
             ++child;
             fup[v]= min(fup[v], fup[to]);
             if (fup[to]>=tin[v])
                isco[v]= true;
            }
       }
       go= listt[go].next;
    }
    if (p==0) isco[v]= false;
    if (child> 1)
        isco[v]= true;
}

int main()
{
    freopen ("crossing.in", "r", stdin);
    freopen ("crossing.out", "w", stdout);

    int start, nmax= 0, a,b;
    while(scanf("%d%d", &a, &b)!=EOF)
    {
       add(a,b);
       start= a;
       nmax= max(nmax, max(a,b) );
    }
    dfs(start, 0);
    int r= nmax;
    while(!isco[r] ) --r;
    for (int i=1; i<r; ++i)
       if (isco[i]) printf("%d ", i);
    printf("%d\n", r);
    return 0;
}
