/* GCC */

#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <map>
#include <set>
#include <iterator>
#include <string>
#include <cstring>
#include <math.h>
#include <stdlib.h>
#include <ctime>

typedef unsigned long long ull;
typedef long long ll;

const int MOD= (int)1e9 + 7;
const double ESP= (double) 1e-7;
const int rmax= ((int)1e7+ 7)/13 +1;
using namespace std;
bool cha;
int kx=13, ky=8;

int findres2(int x, int y, int tx, int ty)
{
    int l=0,r=rmax,mid, px,py;
    while(l+1< r)
    {
        mid= (l+r)>>1;
        if (!cha){
        px= x+ mid*kx;
        py= y+ mid*ky;
        }
        else {
            px= x+ mid*ky;
            py= y+ mid*kx;
        }
        if (px> tx )
            r=mid;
        else if (px <= tx && ( py + (tx-px) <ty))
           r= mid;
        else l= mid;
    }
   if (!cha){
        px= x+ r*kx;
        py= y+ r*ky;
        }
        else {
            px= x+ r*ky;
            py= y+ r*kx;
        }
   if ( py + (tx- px)== ty && (tx- px>=0))
    return (tx-px);
   if (!cha){
        px= x+ l*kx;
        py= y+ l*ky;
        }
        else {
            px= x+ l*ky;
            py= y+ l*kx;
        }
   if ( py + (tx- px)== ty && (tx- px>=0))
    return (tx-px);
   return -1;
}

int findres1(int x, int y, int tx, int ty)
{
    int l=0,r=rmax,mid, px,py;
    while(l+1< r)
    {
        mid= (l+r)>>1;
        if (!cha){
        px= x+ mid*kx;
        py= y+ mid*ky;
        }
        else {
            px= x+ mid*ky;
            py= y+ mid*kx;
        }
        if (py> ty  || px>tx)
            r=mid;
        else l= mid;
    }
   if (!cha){
        px= x+ r*kx;
        py= y+ r*ky;
        }
        else {
            px= x+ r*ky;
            py= y+ r*kx;
        }
   if ( py == ty && (tx- px>=0))
    return (tx-px);
   if (!cha){
        px= x+ l*kx;
        py= y+ l*ky;
        }
        else {
            px= x+ l*ky;
            py= y+ l*kx;
        }
   if ( py == ty && (tx- px>=0))
    return (tx-px);
   return -1;
}

int findres5(int x, int y, int tx, int ty)
{
    int l=0,r=rmax,mid, px,py;
    while(l+1< r)
    {
        mid= (l+r)>>1;
        if (!cha){
        px= x+ mid*kx;
        py= y+ mid*ky;
        }
        else {
            px= x+ mid*ky;
            py= y+ mid*kx;
        }
        if (px> tx )
            r=mid;
        else l= mid;
    }
   if (!cha){
        px= x+ r*kx;
        py= y+ r*ky;
        }
        else {
            px= x+ r*ky;
            py= y+ r*kx;
        }
   if ( px == tx)
    return (ty-py&& (ty- py>=0));
   if (!cha){
        px= x+ l*kx;
        py= y+ l*ky;
        }
        else {
            px= x+ l*ky;
            py= y+ l*kx;
        }
   if ( px== tx && (ty- py>=0))
    return (ty-py);
   return -1;
}

int main()
{
    freopen("stones.in", "r", stdin);
    freopen("stones.out", "w", stdout);

    int x,y;
    cin>> x >> y;
    if (x==y)
        printf("0 0 %d\n", x);
    else {
            int ans=0;
            bool flag= true;
            cha= false;
       ans= findres2(0,0,x,y);
       if (ans!=-1 && flag)
        printf("0 0 %d", ans), flag= false;
       ans= findres2(2,1, x,y);
       if (ans!=-1 && flag)
        printf("0 0 %d", ans), flag= false;
       ans= findres2(5,3, x,y);
       if (ans!=-1 && flag)
        printf("0 0 %d", ans), flag= false;
        ans= findres2(7,4, x,y);
       if (ans!=-1 && flag)
        printf("0 0 %d", ans), flag= false;
        ans= findres2(10,6, x,y);
       if (ans!=-1 && flag)
        printf("0 0 %d", ans), flag= false;

        // swapp
        cha= true;
        ans= findres2(0,0,y,x);
       if (ans!=-1 && flag)
        printf("0 0 %d", ans), flag= false;
       ans= findres2(2,1, y,x);
       if (ans!=-1 && flag)
        printf("0 0 %d", ans), flag= false;
       ans= findres2(5,3, y,x);
       if (ans!=-1 && flag)
        printf("0 0 %d", ans), flag= false;
        ans= findres2(7,4, y,x);
       if (ans!=-1 && flag)
        printf("0 0 %d", ans), flag= false;
        ans= findres2(10,6, y,x);
       if (ans!=-1 && flag)
        printf("0 0 %d", ans), flag= false;
       // in x
       //********************************************************
       cha= false;
       ans= findres1(0,0,x,y);
       if (ans!=-1 && flag)
        printf("%d 0 0", ans), flag= false;
       ans= findres1(2,1, x,y);
       if (ans!=-1 && flag)
        printf("%d 0 0", ans), flag= false;
       ans= findres1(5,3, x,y);
       if (ans!=-1 && flag)
        printf("%d 0 0", ans), flag= false;
        ans= findres1(7,4, x,y);
       if (ans!=-1 && flag)
        printf("%d 0 0", ans), flag= false;
        ans= findres1(10,6, x,y);
       if (ans!=-1 && flag)
        printf("%d 0 0", ans), flag= false;
        // swapp
        cha= true;
        ans= findres1(0,0,y,x);
       if (ans!=-1 && flag)
        printf("%d 0 0", ans), flag= false;
       ans= findres2(2,1, y,x);
       if (ans!=-1 && flag)
        printf("%d 0 0", ans), flag= false;
       ans= findres1(5,3, y,x);
       if (ans!=-1 && flag)
        printf("%d 0 0", ans), flag= false;
        ans= findres1(7,4, y,x);
       if (ans!=-1 && flag)
        printf("%d 0 0", ans), flag= false;
        ans= findres1(10,6, y,x);
       if (ans!=-1 && flag)
        printf("%d 0 0", ans), flag= false;

       //in y
       //*************************************************
       cha= false;
       ans= findres5(0,0,x,y);
       if (ans!=-1 && flag)
        printf("0 %d 0", ans), flag= false;
       ans= findres5(2,1, x,y);
       if (ans!=-1 && flag)
        printf("0 %d 0", ans), flag= false;
       ans= findres5(5,3, x,y);
       if (ans!=-1 && flag)
        printf("0 %d 0", ans), flag= false;
        ans= findres5(7,4, x,y);
       if (ans!=-1 && flag)
        printf("0 %d 0", ans), flag= false;
        ans= findres5(10,6, x,y);
       if (ans!=-1 && flag)
        printf("0 %d 0", ans), flag= false;
        // swapp
        cha= true;
        ans= findres5(0,0,y,x);
       if (ans!=-1 && flag)
        printf("0 %d 0", ans), flag= false;
       ans= findres5(2,1, y,x);
       if (ans!=-1 && flag)
        printf("0 %d 0", ans), flag= false;
       ans= findres5(5,3, y,x);
       if (ans!=-1 && flag)
        printf("0 %d 0", ans), flag= false;
        ans= findres5(7,4, y,x);
       if (ans!=-1 && flag)
        printf("0 %d 0", ans), flag= false;
        ans= findres5(10,6, y,x);
       if (ans!=-1 && flag)
        printf("0 %d 0", ans), flag= false;
        printf("\n");
    }
    return 0;
}
