/* GCC */
#include <stdio.h>
#include <malloc.h>
#include <algorithm>

using namespace std;

struct graph{
    unsigned long mn;
    struct grafel{
    unsigned long No;
    struct grafel *next;
    };
    struct grafel **cur;
    unsigned long n,*ans,ta;
    struct el {
        unsigned long col,par;
        bool vis;
    } *ver;
    graph(){
        mn = 1234567;
        n = 0;
        cur = (struct grafel **) calloc(sizeof(struct grafel *),mn+1);
        for (unsigned long i=0;i<=mn;i++)
            cur[i]=NULL;
        ver = (struct el *) calloc (sizeof(struct el),mn+1);
        for (unsigned long i=0;i<=mn;i++)
            ver[i].col=ver[i].par=ver[i].vis=0;
        ans = (unsigned long *) calloc(sizeof(unsigned long),mn);
        ta = 0;
    }
    void add(unsigned long v1,unsigned long v2){
        if (v1>n) n=v1;
        if (v2>n) n=v2;
        struct grafel *tp;
        tp = cur[v1];
        cur[v1] = (struct grafel *) malloc(sizeof(struct grafel));
        cur[v1]->next = tp;
        cur[v1]->No = v2;
    }
    void paint(unsigned long p,unsigned long v,unsigned long *i){
        struct grafel *tp;
        ver[v].col=(*i)++;
        ver[v].par=p;
        ver[v].vis=1;
        for (tp=cur[v];tp;tp=tp->next) if (!ver[tp->No].vis) paint(v,tp->No,i);
    }
    void repaint(unsigned long v){
        struct grafel *tp;
        if (v!=1)
        ver[v].vis=1;
        for (tp=cur[v];tp;tp=tp->next) {
            if ((ver[tp->No].col<ver[v].col)&&(ver[v].par!=(tp->No))) ver[v].col=ver[tp->No].col;
            if (!ver[tp->No].vis) repaint(tp->No);
        }/*
        for (tp=cur[v];tp;tp=tp->next) {

        }*/
    }
    void f(unsigned long v) {
        struct grafel *tp;
        ver[v].vis=1;
        if (ver[v].par&&ver[v].col>ver[ver[ver[v].par].par].col) ans[ta++]=ver[v].par;
        for (tp=cur[v];tp;tp=tp->next) {
            if (!ver[tp->No].vis) f(tp->No);
        }
    }
};

int main()
{
    unsigned long a,b;
    struct graph g;
    freopen("crossing.in","r",stdin);
freopen("crossing.out","w",stdout);
    while (scanf("%lu%lu",&a,&b)+1) {
        g.add(a,b);
        g.add(b,a);
    }
    a = 0;
    g.paint(0,1,&a);
    for (unsigned long i=0;i<=g.mn;i++)
            g.ver[i].vis=0;
    g.repaint(1);
    for (unsigned long i=0;i<=g.mn;i++)
            g.ver[i].vis=0;
    g.f(1);
    sort(g.ans,g.ans+g.ta);
    printf("%lu",g.ans[0]);
    for (unsigned long i=1;i<g.ta;i++)
        printf(" %lu",g.ans[i]);
    puts("");
    return 0;
}
