{ Free Pascal }
program crossing;
const maxn = 2000;
      inf = 10000;
type TMatrix = array [1..maxn, 1..maxn] of word;
type BVector = array [1..maxn] of boolean;
type NVector = array [1..maxn] of word;
var cp:BVector;
    n:word;
    matrix:TMatrix;

procedure findpoint(var matrix:TMatrix; n, start:word; var cp:BVector);
var time, j:word;
    in_t, out_t:NVector;
procedure findcutpoints(v, from:word);
 var i, cnt:word;
 begin
        in_t[v]:=time; inc(time);
        out_t[v]:=in_t[v];
        cnt:=0;
         for i := 1 to n do
          if (i<>from) and (matrix[v,i]<>0) then
           if (in_t[i]<in_t[v]) then
           begin
           if out_t[v]>in_t[i] then
           out_t[v]:=in_t[i];
           end else begin
           if in_t[i]=inf then
            begin
                findcutpoints(i, v);
                if out_t[i]>=in_t[v] then
                 begin
                    cp[v]:=true;
                    inc(cnt);
                 end;
            end;
            if out_t[v]>out_t[i] then
            out_t[v]:=out_t[i];
         end;
         if cp[v] then
          if from=0 then
           cp[v]:=(cnt>=2) else
           cp[v]:=(cnt>=1);
 end;
 begin
        time:=1;
        for j := 1 to n do
         begin
            cp[j]:=false;
            in_t[j]:=inf;
            out_t[j]:=inf;
         end;
         findcutpoints(start,0);
 end;

function get_max(a, b:word):word;
 begin
        if a>b then get_max:=a
         else
          get_max:=b;
 end;

procedure read_data(var matrix:TMatrix; var n:word);
 type TRecord = record
      in_v, out_v:word;
      end;
      TTemp = array [1..maxn*maxn] of TRecord;
 var temp:TTemp;
     count, i, j:word;
 begin
        count:=0;
        n:=0;
        fillchar(temp, sizeof(temp), 0);
         while not (seekeof(input)) do
          begin
          inc(count);
             read(temp[count].in_v,temp[count].out_v);
             if n<get_max(temp[count].in_v,temp[count].out_v)
               then n:=get_max(temp[count].in_v,temp[count].out_v);
          end;
          fillchar(matrix, sizeof(matrix), 0);
          for i := 1 to count do
          begin
           matrix[temp[i].in_v, temp[i].out_v]:=1;
           matrix[temp[i].out_v, temp[i].in_v]:=1;
          end;
 end;

procedure solve(var matrix:TMatrix; var cp:BVector; n:word);
 var i:word;
 begin
        findpoint(matrix, n, 1, cp);
 end;

procedure write_data(var cp:BVector);
 var i:word;
 begin
        for i := 1 to n do
         if cp[i] then write(i,' ');
 end;


begin
        assign(input, 'crossing.in');
        reset(input);
        assign(output, 'crossing.out');
        rewrite(output);
        read_data(matrix, n);
        solve(matrix, cp, n);
        write_data(cp);
end.
