/* GCC */
#include <iostream>
#include <algorithm>
#include <memory.h>
#include <cstdlib>
#include <cstring>
#include <vector>
#include <string>
#include <stack>
#include <cmath>
#include <ctime>
#include <queue>
#include <map>
#include <set>

using namespace std;

#define pb push_back
#define mp make_pair
#define ppb pop_back
#define sd second
#define fs first

#define inf 1000000007
#define nmax 1250010
#define mmax 1250010
#define eps 1e-7

struct edge
{
	int to, n;
} e[2 * mmax];

int ptr, last[nmax], tin[nmax], fup[nmax];
int a, b, n, Timer, s[nmax], p[nmax], pt;
bool was[nmax], art[nmax];
/*
void dfs(int v, int p = -1)
{
	was[v] = true; 
	fup[v] = tin[v] = ++Timer;
	for(int i = last[v]; i > 0; i = e[i].n)
	{
		int &to = e[i].to;
		if(p != to)
		{
			if(!was[to])
			{
				dfs(to, v); ++children[v];
				fup[v] = min(fup[v], fup[to]);
				if(fup[to] >= tin[v] && p != -1)
					 art[v] = true;
			}
			else
				fup[v] = min(fup[v], tin[to]);
		}
	}
	if(p == -1 && children[v] > 1)
		art[v] = true;
}
*/
void iterative_dfs(int vv)
{
	pt = 0; s[++pt] = vv; p[pt] = -1;
	int v, pr, ch = 0;
	while(true)
	{
	a : v = s[pt]; pr = p[pt];
		//cout << v << " " << pr << endl;
		was[v] = true;
		if(!fup[v]) fup[v] = tin[v] = ++Timer;
		for(int i = last[v]; i; i = e[i].n)
			if(e[i].to != pr)
			{
				if(!was[e[i].to])
				{
					s[++pt] = e[i].to; p[pt] = v;
					if(v == vv) ++ch;
					goto a;
				}
				else
					fup[v] = min(fup[v], tin[e[i].to]);
			}
		if(pr != -1 && pr != vv)
		{
			fup[pr] = min(fup[pr], fup[v]);
			if(fup[v] >= tin[pr])
				art[pr] = true;
		}
		if(pr == -1 && ch > 1)
			art[v] = true;
		if(--pt == 0)
			break;
	}	
}

int main()
{
	freopen("crossing.in", "r", stdin); freopen("crossing.out", "w", stdout);
	while(scanf("%d%d", &a, &b) != -1)
	{
		e[++ptr].n = last[a]; last[a] = ptr; e[ptr].to = b;
		e[++ptr].n = last[b]; last[b] = ptr; e[ptr].to = a;
		n = max(n, max(a, b));
	}
	for(int i = 1; i <= n; ++i)
		if(!was[i])
			iterative_dfs(i);
	ptr = 0;
	for(int i = 1; i <= n; ++i)
		if(art[i])
			last[++ptr] = i;
	if(ptr > 0) printf("%d", last[1]);
	for(int i = 2; i <= ptr; ++i)
		printf(" %d", last[i]);
	printf("\n");
}
