/* GCC */
#include <algorithm>
#include <iostream>
#include <stdio.h>
#include <vector>
#include <math.h>
using namespace std;
#define tin first
#define fup second
#define pii pair<int,int>
#define pb push_back
#define All(x) x.begin(),x.end()

const int nmax = 1300000;

int t, a, b;
pii T[nmax];
vector < int > G[nmax], Res;
bool Used[nmax];

void dfs(int v, int p = -1)
{
    Used[v] = 1;
    T[v].tin = T[v].fup = ++t;
    int c = 0;
    for (int i = 0; i < G[v].size(); ++i)
    {
        int d = G[v][i];
        if (d == p) continue;
        if (!Used[d])
        {
            dfs(d, v);
            T[v].fup = min(T[v].fup, T[d].fup);
            if (T[v].tin <= T[d].fup && p != -1)
                Res.pb(v);
            ++c;
        }
        else T[v].fup = min(T[v].fup, T[d].tin);
    }
    if (c > 1 && p == -1)
        Res.pb(v);
}

int main()
{
    freopen("crossing.in","r",stdin);
    freopen("crossing.out","w",stdout);
    while (scanf("%d %d", &a, &b) != -1)
    {
        G[a-1].pb(b-1);
        G[b-1].pb(a-1);
    }
    dfs(0);
    sort(All(Res));
    printf("%d", Res[0]+1);
    for (int i = 1; i < Res.size(); ++i)
        printf(" %d", Res[i]+1);
    printf("\n");
}
