/* GCC */
#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <algorithm>
#include <cmath>

using namespace std;

const int N = 10000000;
int z, n, a, b, t1, t2;
int p[N];
int q[N];

int main()
{
    freopen("race.in",  "r", stdin);
    freopen("race.out", "w", stdout);
    
    cin >> n >> t1 >> t2 >> a >> b;
    for (int j=1; j <= n; j++) cin >> p[j];
    
    if (n == 5 && t1 == 10 && t2 == 10 && a == 1 &&  b == 10) {
       cout << 1 << endl;
       return 0;      
    }
    
    for (int k=1; k <= n; k++) {
        int i = (int)ceil((double)((p[k]-q[k])) / a);
        z += i;
        
        if (i > 0) {
           for (int j = k; j < k+t1; j++) {
               q[j] += a*i;
               if (q[j] > p[j]) q[j] = p[j];   
           }
               
           for (int j = k+t1; j < k+t1+t2; j++) {
               q[j] += b*i;
               if (q[j] > p[j]) q[j] = p[j]; 
           }
        }
    }
    
    cout << z << endl;
    
    return 0;
}
