/* GCC */
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <memory.h>
#define N 1300000

using namespace std;

struct edge
{
    int v, n;
};

int n, v, t, st[N], zz, tin[N], tout[N], used[N], timee, ans[N];
edge list[2*N];

void add(int v, int t)
{
    zz++;
    list[zz].v = t;
    list[zz].n = st[v];
    st[v] = zz;
}

void dfs(int v, int p)
{
    int child = 0;
    int mx = 0;
    used[v] = 1;
    timee++;
    tout[v] = tin[v] = timee;
    int i = st[v];
    while (i != 0)
    {
        int t = list[i].v;
        if (!used[t])
        {
            dfs(t, v);
            tout[v] = min(tout[v], tout[t]);
            child++;
            mx = max(mx, tout[t]);
        } else
        if (used[t] == 2)
            tout[v] = min(tout[v], tout[t]); else
        if ((used[t] == 1) && (t != p))
            tout[v] = min(tout[v], tin[t]);
        i = list[i].n;
    }
    if (p == -1)
        if (child > 1)
            ans[n] = v, n++;
    if (p != -1)
        if (mx >= tin[v])
            ans[n] = v, n++;
    used[v] = 2;
}

int main()
{
    freopen("crossing.in", "r", stdin);
    freopen("crossing.out", "w", stdout);
    memset(st, 0, sizeof(st));
    n = 0;
    while (scanf("%d %d", &v, &t) == 2)
        add(v, t), add(t, v);
    dfs(1, -1);
    sort(ans, ans + n);
    for (int i = 0; i < n - 1; i++)
        printf("%d ", ans[i]);
    printf("%d\n", ans[n - 1]);
    return 0;
}
